// 009 u_create_sniffer_base
// 10 dec 2004

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)
unit u_create_sniffer_base;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Db, DBTables, Grids, DBGrids, ComCtrls,
  IBCustomDataSet, IBQuery, IBDatabase, IBTable, IBSQLMonitor, IBSQL;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    Panel4: TPanel;
    Memo1: TMemo;
    DBGrid1: TDBGrid;
    select_: TButton;
    IBDatabase1: TIBDatabase;
    create_table_: TButton;
    drop_table_: TButton;
    insert_: TButton;
    exit_: TButton;
    clear_: TButton;
    create_database_: TButton;
    drop_database_: TButton;
    IBDatabase2: TIBDatabase;
    write_IBDatabase: TIBDatabase;
    IBSQL1: TIBSQL;
    extract_bde_: TButton;
    IBTransaction2: TIBTransaction;
    extract_table: TTable;
    write_ib_sql: TIBSQL;
    local_: TCheckBox;
    write_IBTransaction: TIBTransaction;
    insert_count_edit_: TEdit;
    connect_: TButton;
    disconnect_: TButton;
    read_IBTransaction: TIBTransaction;
    read_IBDatabase: TIBDatabase;
    IBQuery1: TIBQuery;
    procedure FormCreate(Sender: TObject);
    procedure select_Click(Sender: TObject);
    procedure create_table_Click(Sender: TObject);
    procedure drop_table_Click(Sender: TObject);
    procedure insert_Click(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure create_database_Click(Sender: TObject);
    procedure drop_database_Click(Sender: TObject);
    procedure extract_bde_Click(Sender: TObject);
    procedure local_Click(Sender: TObject);
    procedure connect_Click(Sender: TObject);
    procedure disconnect_Click(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation
  uses u_c_log, u_c_display
      , u_strings
      , u_dir
      , u_file
    ;

    {$R *.DFM}

    
    (*$i ..\units\i_pathes.pas *)

    const k_company_list_name= 'company.txt';
          k_address_list_name= 'address.txt';
          k_contact_list_name= 'contact.txt';

    var g_database_disk_path: String= k_database_disk_path;
        g_database_path: String= k_database_path;

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;

        Caption:= g_database_path;
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.local_Click(Sender: TObject);
      begin
        if local_.Checked
          then begin
              g_database_disk_path:= k_local_database_disk_path;
              g_database_path:= k_local_database_path;
            end
          else begin
              g_database_disk_path:= k_database_disk_path;
              g_database_path:= k_database_path;
            end;
         Caption:= g_database_path;
       end; // local_Click

    procedure TForm1.create_database_Click(Sender: TObject);
      begin
        IbDatabase1.Close;

        with IbDatabase1, Params do
        begin
          Connected:= False;

          display('create '+ g_database_path);
          display('  '+ k_database_name);

          f_create_path(g_database_disk_path);
          DatabaseName:= g_database_path+ k_database_name;
          SqlDialect:= 3;
          Clear;

          Add('USER '+ QuotedStr('sysdba'));
          Add('PASSWORD '+ QuotedStr('masterkey'));
          Add('PAGE_SIZE 4096');

          CreateDatabase;
        end; // IbDatabase1
      end; // create_database_Click

    procedure TForm1.drop_database_Click(Sender: TObject);
      begin
        display('> drop_database');
        with IbDatabase2, Params do
        begin
          display('delete '+ k_database_path);
          display('  '+ k_database_name);

          Open;

          DropDatabase;
        end; // IbDatabase1

(*
        If FileExists(k_database_disk_path+ k_database_name)
            Then begin
                display('Erase');
                f_erase(k_database_disk_path+ k_database_name);
              end;
*)
        display('< drop_database');
      end; // drop_database_Click

    procedure TForm1.extract_bde_Click(Sender: TObject);
      var l_c_company_name_list, l_c_address_list, l_c_contact_list: tStringList;
      begin
        l_c_company_name_list:= tStringList.Create;
        l_c_address_list:= tStringList.Create;
        l_c_contact_list:= tStringList.Create;

        With extract_table do
        begin
          DataSource1.DataSet:= extract_table;
          Open;
          First;
          While Not Eof do
          begin
            l_c_company_name_list.Add(FieldByName('Company').AsString);
            l_c_address_list.Add(FieldByName('Addr1').AsString);
            l_c_contact_list.Add(FieldByName('Contact').AsString);

            Next;
          end; // While Not Eof
        end; // With IbQuery1

        l_c_company_name_list.SaveToFile(g_database_disk_path+ k_company_list_name);
        l_c_company_name_list.Free;

        l_c_address_list.SaveToFile(g_database_disk_path+ k_address_list_name);
        l_c_address_list.Free;

        l_c_contact_list.SaveToFile(g_database_disk_path+ k_contact_list_name);
        l_c_contact_list.Free;
      end; // extract_bde_Click

    procedure execute_sql(p_sql_query: String);
        // -- this procedure will sent any "write" sql request to the remote database
      begin
        with Form1, write_ib_sql do
        begin
          Close;

          with Sql do
          begin
            Clear;
            Add(p_sql_query);
          end; // with Sql

          display(write_IbDatabase.DatabaseName);
          display_strings(Sql);

          Try
            write_IbDatabase.Open;
            write_IbDatabase.DefaultTransaction.Active:= True;

            display(write_IbDatabase.DefaultTransaction.Name);

            if write_IbDatabase.DefaultTransaction.Active
              then display('active')
              else display('closed');

            if write_IbDatabase.DefaultTransaction.InTransaction
              then begin
                  display('Commit_previous');
                  write_IbDatabase.DefaultTransaction.Commit;
                end;

            display('StartTransaction');
            write_IbDatabase.DefaultTransaction.StartTransaction;

            if write_IbDatabase.DefaultTransaction.Active
              then display('active')
              else display('closed');

            display('Exec');
            ExecQuery;
            // interbase transaction is not active

            display('Commit');
            write_IbDatabase.DefaultTransaction.Commit;

            display('  ok');
          except
            on e: Exception do
              begin
                write_IbDatabase.DefaultTransaction.RollBack;
                display('  *** pb_exec '+ e.Message);
              end;
          end;
        end; // with IbSql1
      end; // execute_sql

    procedure TForm1.create_table_Click(Sender: TObject);
      begin
        write_IbDatabase.Close;
        write_IbDatabase.DatabaseName:= g_database_path+ k_database_name;

        execute_sql(k_sql_create_table);
      end; // create_Click

    procedure TForm1.drop_table_Click(Sender: TObject);
      begin
        execute_sql(k_sql_drop_table);
      end; // drop_Click

    function f_double_to_sql_string(p_double: Double): String;
      var l_save_decimal_separator: Char;
      begin
        l_save_decimal_separator:= DecimalSeparator;
        DecimalSeparator:= '.';
        Result:= FloatToStr(p_double);
        DecimalSeparator:= l_save_decimal_separator;
        Result:= f_replace_character(Result, ',', '.');
      end; // l_save_decimal_separator

    procedure TForm1.insert_Click(Sender: TObject);

      procedure insert_generic(p_id: Integer; p_company_name, p_address, p_contact: String;
          p_amount_due: Double);
        var l_values: String;
            l_sql_request: String;
        begin
          l_values:=
                IntToStr(p_id)+ ', '
              + QuotedStr(p_company_name)+ ', '
              + QuotedStr(p_address)+ ', '
              + QuotedStr(p_contact)+ ', '
              + f_double_to_sql_string(p_amount_due);

          l_sql_request:= k_sql_insert_partial
            + ' ('+ l_values+ ')';
          // display(l_sql_request);
          execute_sql(l_sql_request);
        end; // insert_generic

      var l_c_company_name_list, l_c_address_list, l_c_contact_list: tStringList;
          l_line_index: Integer;

          l_sample_count: Integer;
          l_company_name_random, l_address_random, l_contact_random: String;
          l_amount_due_random: Double;

      begin // insert_Click
        display('> insert_Click');
        write_IbDatabase.Close;
        write_IbDatabase.DatabaseName:= g_database_path+ k_database_name;

        l_c_company_name_list:= tStringList.Create;
        l_c_company_name_list.LoadFromFile(g_database_disk_path+ k_company_list_name);
        l_sample_count:= l_c_company_name_list.Count;

        l_c_address_list:= tStringList.Create;
        l_c_address_list.LoadFromFile(g_database_disk_path+ k_address_list_name);

        l_c_contact_list:= tStringList.Create;
        l_c_contact_list.LoadFromFile(g_database_disk_path+ k_contact_list_name);

        for l_line_index:= 0 to StrToInt(insert_count_edit_.Text)- 1 do
        begin
          l_company_name_random:= l_c_company_name_list[Random(l_sample_count)];
          l_address_random:= l_c_address_list[Random(l_sample_count)];
          l_contact_random:= l_c_contact_list[Random(l_sample_count)];
          l_amount_due_random:= 23000+ Random(150000)/ 10;
          display(Format('%3d %-35s %6.2f', [l_line_index, l_company_name_random, 1.0* l_amount_due_random]));

          insert_generic(1000+ l_line_index, l_company_name_random, l_address_random,
              l_contact_random, l_amount_due_random);
        end; // for l_line_index

        display('< insert_Click');
      end; // insert_Click

    procedure TForm1.connect_Click(Sender: TObject);
      begin
        disconnect_Click(Nil);
        display('reconnect');
        read_ibDatabase.DatabaseName:= g_database_path+ k_database_name;
        display(read_ibDatabase.DatabaseName);
        read_ibDatabase.Connected:= True;
      end; // connect_Click

    procedure TForm1.select_Click(Sender: TObject);
      begin
        display('> select_Click');

        DataSource1.DataSet:= IbQuery1;

        with IbQuery1 do
        begin
          Close;
          Database:= read_ibDatabase;

          with Sql do
          begin
            Clear;
            Add(UpperCase(k_sql_select));
            display(Database.DatabaseName);
            if Database.Connected
              then display('connected');
            display(Sql.Text);

            Open;
          end; // with Sql
        end; // with IbQuery1

        display('< select_Click');
      end; // select_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure TForm1.disconnect_Click(Sender: TObject);
      begin
        display('disconnect');
        read_ibDatabase.Connected:= False;
      end; // disconnect_Click

end.





